﻿using System;

namespace OpcLabs.UnitTestLib
{
    // IMPROVE: verify that the sections are invoked in the proper order
    static public class TestSection
    {
        #region Static Public Methods

        static public void Act()
        {
            Section(TestSectionState.Act);
        }

        static public void Arrange()
        {
            Section(TestSectionState.Arrange);
        }

        static public void Assert()
        {
            Section(TestSectionState.Assert);
        }

        #endregion



        #region Static Private Methods

        static private void Section(TestSectionState state)
        {
            if (state == _state)
                return;
            _state = state;

            AssertUtilities.WriteLine();

            string title = $"{_state.ToString().ToUpper()} SECTION";
            AssertUtilities.WriteLine(title);
            AssertUtilities.WriteLine(new String('=', title.Length));
        }

        #endregion



        #region Static Private Fields

        static private TestSectionState _state = TestSectionState.None;

        #endregion
    }
}
