﻿
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc;
using OpcLabs.EasyOpcLiveTest.DataAccess.Environment;

namespace OpcLabs.EasyOpcLiveTest.DataAccess
{
    // ReSharper disable once InconsistentNaming
    partial class EasyDAClientTest_Com
    {
        public const string UnregisteredProgId = "ProgId.Unregistered";



        // IMPROVE: [DynamicData(nameof(OpcLabs_KitServer.ReadableItemCatalogEntryDataRows), typeof(OpcLabs_KitServer))]
        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void ReadItemCatalogTest_Com_Basic([NotNull] DAItemCatalogEntry itemCatalogEntry)
        {
            ReadItemCatalogTest_Basic(DALiveTestEnvironment.OpcLabs_KitServer.ServerDescriptors.WithProgId, itemCatalogEntry);
        }

        // IMPROVE: we currently do not have write-only items in KitServer
        //[DynamicData(nameof(OpcLabs_KitServer.NonReadableItemCatalogEntryDataRows), typeof(OpcLabs_KitServer))]
        //[TestCategory("Live")]
        //[TestCategory("OpcClassic")]
        //[TestCategory("OpcDataAccess")]
        //[TestMethod]
        //public void ReadItemCatalogTest_Com_NonReadable([NotNull] DAItemCatalogEntry itemCatalogEntry)
        //{
        //    ReadItemTest_NonReadable(TestEnvironment.OpcFoundation_XmlDaSampleServer.ServerDescriptors.Http, itemCatalogEntry.Element);
        //}

        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void ReadItemTest_Com_Localhost()
        {
            ServerDescriptor serverDescriptor = DALiveTestEnvironment.OpcLabs_KitServer.ServerDescriptors.WithProgId;
            serverDescriptor.MachineName = "localhost";
            ReadItemTest_Basic(serverDescriptor, OpcLabs_KitServer.ItemIds.Constant_BOOL, typeof(bool));
        }

        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void ReadItemTest_Com_ThisComputer()
        {
            ServerDescriptor serverDescriptor = DALiveTestEnvironment.OpcLabs_KitServer.ServerDescriptors.WithProgId;
            serverDescriptor.MachineName = System.Environment.MachineName;
            ReadItemTest_Basic(serverDescriptor, OpcLabs_KitServer.ItemIds.Constant_BOOL, typeof(bool));
        }

        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void ReadItemTest_Com_UnknownItemId()
        {
            ReadItemTest_UnknownItemId(DALiveTestEnvironment.OpcLabs_KitServer.ServerDescriptors.WithProgId, "unknown item");
        }

        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void ReadMultipleItemsCatalogTest_Com()
        {
            ReadMultipleItemsCatalogTest(DALiveTestEnvironment.OpcLabs_KitServer.ServerDescriptors.WithProgId, OpcLabs_KitServer.AllItemCatalogEntries);
        }


        //[DynamicData(nameof(DALiveTestEnvironment.OpcLabs_KitServer_OptimisticSupportedServerDescriptorDataRows), typeof(DALiveTestEnvironment))]
        //[TestCategory("Live")]
        //[TestCategory("OpcClassic")]
        //[TestCategory("OpcDataAccess")]
        //[TestMethod]
        //public void ReadItemTest_Com_NotSupported([NotNull] ServerDescriptor serverDescriptor)
        //{
        //    TestSection.Arrange();
        //    AssertUtilities.WriteLine(serverDescriptor);
        //    EasyDAClient client = CreateClient();
        //    DAItemDescriptor itemDescriptor = "Static/Analog Types/Int";

        //    TestSection.Act();
        //    try
        //    {
        //        try
        //        {
        //            client.ReadItem(serverDescriptor, itemDescriptor);
        //        }
        //        finally
        //        {
        //            TestSection.Assert();
        //        }
        //    }
        //    catch (Exception exception)
        //    {
        //        AssertUtilities.WriteLine(exception.GetType());
        //        AssertUtilities.WriteLine(exception.Message ?? String.Empty);
        //        Assert.IsInstanceOfType(exception, typeof(OpcException));
        //        var opcException = (OpcException) exception;
        //        Exception innerException = opcException.InnerException;
        //        Assert.IsNotNull(innerException);
        //        AssertUtilities.WriteLine(innerException.GetType());
        //        string innerExceptionMessage = innerException.Message;
        //        AssertUtilities.WriteLine(innerExceptionMessage ?? String.Empty);
        //        Assert.IsInstanceOfType(innerException, typeof(NotSupportedException));
        //        StringAssert.Contains(innerExceptionMessage, "'Com'");
        //        return;
        //    }
        //    Assert.Fail("No exception");
        //}
    }
}
