﻿
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpcLiveTest.DataAccess.Environment;

namespace OpcLabs.EasyOpcLiveTest.DataAccess
{
    // ReSharper disable once InconsistentNaming
    partial class EasyDAClientTest_Com
    {
        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("TimeDomain")]
        [TestMethod]
        public void ChangeItemSubscriptions_Basic()
        {
            ChangeItemSubscriptions_Basic(
                DALiveTestEnvironment.OpcLabs_KitServer.ServerDescriptors.WithProgId,
                OpcLabs_KitServer.ItemIds.Ramp_1s);
        }

        // IMPROVE: [DynamicData(nameof(OpcLabs_KitServer.ReadableItemCatalogEntryDataRows), typeof(OpcLabs_KitServer))]
        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("TimeDomain")]
        [TestMethod]
        public void SubscribeItemCatalogTest_Com_Basic([NotNull] DAItemCatalogEntry itemCatalogEntry)
        {
            SubscribeItemCatalogTest_Basic(DALiveTestEnvironment.OpcLabs_KitServer.ServerDescriptors.WithProgId, itemCatalogEntry);
        }

        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("TimeDomain")]
        [TestMethod]
        public void SubscribeItemTest_Com_Error_UnknownItemId()
        {
            SubscribeItemTest_Error(
                DALiveTestEnvironment.OpcLabs_KitServer.ServerDescriptors.WithProgId,
                "unknown_item");
        }

        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("TimeDomain")]
        [TestMethod]
        public void SubscribeItemTest_Com_EventPull()
        {
            SubscribeItemTest_Basic(
                DALiveTestEnvironment.OpcLabs_KitServer.ServerDescriptors.WithProgId,
                OpcLabs_KitServer.ItemIds.Ramp_1s,
                useEventPull: true,
                expectedType: typeof(double));
        }
    }
}
