﻿// $Header: RootNode.cs 20120904 10:23 AM zbynekz $
// Copyright (c) CODE Consulting and Development, s.r.o., Plzen. All rights reserved.

using System;
using System.Diagnostics.CodeAnalysis;
using JetBrains.Annotations;
using OpcLabs.BaseLib.Annotations;
using OpcLabs.BaseLib.Diagnostics;
using OpcLabs.BaseLib.Testing;
using OpcLabs.EasyOpc.DataAccess.LiveMapping;

namespace OpcLabs.EasyOpcLiveTest.Legacy.Environment.OpcKitServer
{
    [CLSCompliant(false)]
    [Designable(false)]
    [SuppressMessage("OpcLabs.VSI", "CX5213:ExpandableObjectConverterImpliesDesignable")]
#pragma warning disable 3021
    public class RootNode : DAMappedNode
#pragma warning restore 3021
    {
        [SuppressMessage("Microsoft.Usage", "CA2214:DoNotCallOverridableMethodsInConstructors")]    // caused by Code Contracts
        public RootNode()
        {
            Greenhouse = new GreenhouseNode();
            Simulation = new SimulationNode();
        }

        [DANode]
        [InvalidValue(null, typeof(ArgumentNullException))]
        [NotNull]
        public GreenhouseNode Greenhouse { get; set; }  // non-nullness by invariant

        [DANode]
        [InvalidValue(null, typeof(ArgumentNullException))]
        [NotNull]
        public SimulationNode Simulation { get; set; }  // non-nullness by invariant

        [UsedImplicitly]
        private void ObjectInvariant()
        {
            // Auto-implemented properties
            Check.Invariant(Greenhouse != null);
            Check.Invariant(Simulation != null);
        }
    }
}
