﻿
using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.DataAccess
{
    partial class EasyDAClientTest
    {
        #region Test Methods

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void GetServiceTest_IDisposable()
        {
            TestSection.Arrange();
            IServiceProviderTest.GetServiceTest(new EasyDAClient(), typeof(IDisposable));
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void GetServiceTest_IEasyDAClient()
        {
            TestSection.Arrange();
            IServiceProviderTest.GetServiceTest(new EasyDAClient(), typeof(IEasyDAClient));
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void GetServiceTest_IEasyDAClientDequeuing()
        {
            TestSection.Arrange();
            IServiceProviderTest.GetServiceTest(new EasyDAClient(), typeof(IEasyDAClientDequeuing));
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void GetServiceTest_IEasyDAClientSettings()
        {
            TestSection.Arrange();
            IServiceProviderTest.GetServiceTest(new EasyDAClient(), typeof(IEasyDAClientSettings));
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void GetServiceTest_ILicenseInfoProvider()
        {
            TestSection.Arrange();
            IServiceProviderTest.GetServiceTest(new EasyDAClient(), typeof(ILicenseInfoProvider));
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void GetServiceTest_Negative_IEasyDAClientProvider()
        {
            TestSection.Arrange();
            IServiceProviderTest.GetServiceTest_Negative(new EasyDAClient(), typeof(IEasyDAClientProvider));
        }

        #endregion
    }
}
