﻿
using System;
using System.Diagnostics;
using System.IO;
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.IO.Extensions;
using OpcLabs.EasyOpc.UA.DataTypeModel.Implementation;

namespace OpcLabs.EasyOpcTest.UA.DataTypeModel.Internal
{
    [TestClass]
    public partial class TypeDescriptionExamplesTest : UAOpcBinaryDataTypeSystemTest
    {
        #region Static Private Properties

        [NotNull]
        static private byte[] TypeDictionaryByteArray
        {
            get
            {
                Type type = typeof(UAOpcBinaryDataTypeSystemTest);
                Stream stream = type.Assembly.GetManifestResourceStream(type, "TypeDescriptionExamplesTypeDictionary.xml");
                Debug.Assert(stream != null);
                byte[] dictionaryByteArray = stream.ReadToArrayOfBytes();
                return dictionaryByteArray;
            }
        }

        #endregion



        #region Test Methods

        [TestMethod]
        public void DecodeErrorTest_BinarySystemDataTypeDescriptionNotFound() =>
            DecodeErrorTest(null,
                TypeDictionaryByteArray,
                "unknown",
                new byte[16],
                UADataTypeModelErrorCodes.DataTypeSystemDataTypeDescriptionNotFound);

        #endregion
    }
}
