﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class Siemens_WinCCRuntimeProfessional_Test : UAInteroperabilityWorkshopTest
    {
        public override IEnumerable<UANodeDescriptor> ArrayReadableNodes => new UANodeDescriptor[0];

        public override IEnumerable<UANodeDescriptor> ArrayWriteableNodes => new UANodeDescriptor[0];

        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "nsu=urn:RTPRO01:Siemens.Automation.WinCCRtPro;ns=1;s=t|VT_R8",
            "nsu=urn:RTPRO01:Siemens.Automation.WinCCRtPro;ns=1;s=t|VT_R8(1)"
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://RTPRO01:4861" };

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new[]
        {
            nameof(Group001_Session_Test09_CreateSession_Https_None),
            nameof(Group001_Session_Test10_ActivateSession_X509Certificate),
            nameof(Group002_ViewServices_Test07_TranslateBrowsePathToNodeId_Components),
            nameof(Group003_AttributeServices_Test05_Read_Array_IndexRange),
            nameof(Group003_AttributeServices_Test07_Write_Array_IndexRange),
            nameof(Group005_InformationModel_Test04_Browse_Read_SessionDiagnosticsArray),
            nameof(Group009_DataChange_Test05_AbsoluteDeadbandFilter),
            nameof(Group013_Discovery_Test03_FindServers_LDS_ServerPresence),
            nameof(Group102_Session2_Test03_CreateSession_Https_Basic256Sha256)
        });

        public override string Password => "opcua";

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[] { "nsu=urn:RTPRO01:Siemens.Automation.WinCCRtPro;ns=1;s=t|VT_R8(1)_NC" };

        public override string UserName => "opcua";

        public override IEnumerable<UANodeDescriptor> WriteableNodes => new UANodeDescriptor[] { "nsu=urn:RTPRO01:Siemens.Automation.WinCCRtPro;ns=1;s=t|VT_R8(1)_NC" };
    }
}
